diff --git a/gcc/ada/ChangeLog b/gcc/ada/ChangeLog
index 4e0b0a8..f1904b1 100644
--- a/gcc/ada/ChangeLog
+++ b/gcc/ada/ChangeLog
@@ -1,3 +1,11 @@
+2013-07-23   Ondřej Bílka  <neleai@seznam.cz>
+
+	* gnat_rm.texi: Fix typos in ada.
+	* gnat_ugn.texi: Likewise.
+	* init.c: Likewise.
+	* namet.h: Likewise.
+	* terminals.c: Likewise.
+
 2013-07-21   OndÅej BÃ­lka  <neleai@seznam.cz>
 
 	* gcc-interface/gigi.h: Likewise.
diff --git a/gcc/ada/gnat_rm.texi b/gcc/ada/gnat_rm.texi
index c1109b9..9c11576 100644
--- a/gcc/ada/gnat_rm.texi
+++ b/gcc/ada/gnat_rm.texi
@@ -2083,7 +2083,7 @@ pragma Postcondition (if C2 then Pred2);
 The precondition ensures that one and only one of the conditions is
 satisfied on entry to the subprogram.
 The postcondition ensures that for the condition that was True on entry,
-the corrresponding consequence is True on exit. Other consequence expressions
+the corresponding consequence is True on exit. Other consequence expressions
 are not evaluated.
 
 A precondition @code{P} and postcondition @code{Q} can also be
@@ -17394,7 +17394,7 @@ multiple instantiations.
 @section @code{GNAT.Byte_Order_Mark} (@file{g-byorma.ads})
 @cindex @code{GNAT.Byte_Order_Mark} (@file{g-byorma.ads})
 @cindex UTF-8 representation
-@cindex Wide characte representations
+@cindex Wide character representations
 
 @noindent
 Provides a routine which given a string, reads the start of the string to
@@ -20595,11 +20595,11 @@ A complete description of the AIs may be found in
 
 
 @item
-@emph{AI-0177 Parameterized expressions (2010-07-10)}
+@emph{AI-0177 Parametrized expressions (2010-07-10)}
 @cindex AI-0177 (Ada 2012 feature)
 
 @noindent
-  The new Ada 2012 notion of parameterized expressions is implemented. The form
+  The new Ada 2012 notion of parametrized expressions is implemented. The form
   is:
 @smallexample
   @i{function specification} @b{is} (@i{expression})
diff --git a/gcc/ada/gnat_ugn.texi b/gcc/ada/gnat_ugn.texi
index 0a5f07d..971fc60 100644
--- a/gcc/ada/gnat_ugn.texi
+++ b/gcc/ada/gnat_ugn.texi
@@ -341,7 +341,7 @@ file names on operating systems with a limit on the length of names.
 @item
 @ref{Preprocessing with gnatprep}, describes @code{gnatprep}, a
 preprocessor utility that allows a single source file to be used to
-generate multiple or parameterized source files by means of macro
+generate multiple or parametrized source files by means of macro
 substitution.
 
 @item
@@ -3812,7 +3812,7 @@ temporary use of special test software.
 
 @item -gnateS
 @cindex @option{-gnateS} (@command{gcc})
-Synonym of @option{-fdump-scos}, kept for backards compatibility.
+Synonym of @option{-fdump-scos}, kept for backwards compatibility.
 
 @item ^-gnatet^/TARGET_DEPENDENT_INFO^
 @cindex @option{-gnatet} (@command{gcc})
@@ -7473,7 +7473,7 @@ preprocessing.
 @noindent
 The actual preprocessing function is described in details in section
 @ref{Preprocessing with gnatprep}. This section only describes how integrated
-preprocessing is triggered and parameterized.
+preprocessing is triggered and parametrized.
 
 @table @code
 
@@ -7986,7 +7986,7 @@ all other options.
 @item -a
 @cindex @option{-a} @command{gnatbind}
 Indicates that, if supported by the platform, the adainit procedure should
-be treated as an initialisation routine by the linker (a constructor). This
+be treated as an initialization routine by the linker (a constructor). This
 is intended to be used by the Project Manager to automatically initialize
 shared Stand-Alone Libraries.
 
@@ -10956,7 +10956,7 @@ being processed.
 @item ^-wq^/WARNINGS=QUIET^
 @cindex @option{^-wq^/WARNINGS=QUIET^} (@command{gnatelim})
 Quiet warning mode - some warnings are suppressed. In particular warnings that
-indicate that the analysed set of sources is incomplete to make up a
+indicate that the analyzed set of sources is incomplete to make up a
 partition and that some subprogram bodies are missing are not generated.
 @end table
 
@@ -10971,7 +10971,7 @@ driver (see @ref{The GNAT Driver and Project Files}).
 If some program uses a precompiled Ada library, it can be processed by
 @code{gnatelim} in a usual way. @code{gnatelim} will newer generate an
 Eliminate pragma for a subprogram if the body of this subprogram has not
-been analysed, this is a typical case for subprograms from precompiled
+been analyzed, this is a typical case for subprograms from precompiled
 libraries. Switch @option{^-wq^/WARNINGS=QUIET^} may be used to suppress
 warnings about missing source files and non-analyzed subprogram bodies
 that can be generated when processing precompiled Ada libraries.
@@ -19244,7 +19244,7 @@ The GNAT compiler now supports dimensionality checking. The user can
 specify physical units for objects, and the compiler will verify that uses
 of these objects are compatible with their dimensions, in a fashion that is
 familiar to engineering practice. The dimensions of algebraic expressions
-(including powers with static exponents) are computed from their consistuents.
+(including powers with static exponents) are computed from their constituents.
 
 This feature depends on Ada 2012 aspect specifications, and is available from
 version 7.0.1 of GNAT onwards. The GNAT-specific aspect Dimension_System allows
@@ -19994,14 +19994,14 @@ Finally, you need to call the @code{gcov} tool. The different options of
 @code{gcov} are available in the GCC User's Guide, section 'Invoking gcov'.
 
 This will create annotated source files with a @file{.gcov} extension:
-@file{my_main.adb} file will be analysed in @file{my_main.adb.gcov}.
+@file{my_main.adb} file will be analyzed in @file{my_main.adb.gcov}.
 
 @node Gnat specifics
 @subsection Gnat specifics
 
 Because Ada semantics, portions of the source code may be shared among
 several object files. This is the case for example when generics are
-involved, when inlining is active  or when declarations generate  initialisation
+involved, when inlining is active  or when declarations generate  initialization
 calls. In order to take
 into account this shared code, you need to call @code{gcov} on all
 source files of the tested program at once.
@@ -21932,7 +21932,7 @@ On OpenVMS Alpha systems, tasking delays are implemented
 using Timer System Services. The Task ID is used for the
 identification of the timer request (the @code{REQIDT} parameter).
 If Timers are used in the application take care not to use
-@code{0} for the identification, because cancelling such a timer
+@code{0} for the identification, because canceling such a timer
 will cancel all timers and may lead to unpredictable results.
 
 @node Task-Related Pragmas
@@ -26442,7 +26442,7 @@ integer arithmetic package. The compiler will make calls
 to this package, though only in cases where it cannot be
 sure that @code{Long_Long_Integer} is sufficient to guard against
 intermediate overflows. This package does not use dynamic
-alllocation, but it does use the secondary stack, so an
+allocation, but it does use the secondary stack, so an
 appropriate secondary stack package must be present (this
 is always true for standard full Ada, but may require
 specific steps for restricted run times such as ZFP).
diff --git a/gcc/ada/init.c b/gcc/ada/init.c
index 1b2e188..849c66b 100644
--- a/gcc/ada/init.c
+++ b/gcc/ada/init.c
@@ -1267,7 +1267,7 @@ __gnat_handle_vms_condition (int *sigargs, void *mechargs)
 
   extern int SYS$PUTMSG (void *, int (*)(), void *, unsigned long long);
 
-  /* If it was a DEC Ada specific condtiion, make it GNAT otherwise
+  /* If it was a DEC Ada specific condition, make it GNAT otherwise
      keep the old facility.  */
   if (sigargs [1] & FAC_MASK == DECADA_M_FACILITY)
     SYS$PUTMSG (sigargs, copy_msg, &gnat_facility,
@@ -1296,7 +1296,7 @@ __gnat_handle_vms_condition (int *sigargs, void *mechargs)
 void
 GNAT$STOP (int *sigargs)
 {
-   /* Note that there are no mechargs. We rely on the fact that condtions
+   /* Note that there are no mechargs. We rely on the fact that conditions
       raised from DEClib I/O do not require an "adjust".  Also the count
       will be off by 2, since LIB$STOP didn't get a chance to add the
       PC and PSL fields, so we bump it so PUTMSG comes out right.  */
diff --git a/gcc/ada/namet.h b/gcc/ada/namet.h
index 0bc841a..0361bc9 100644
--- a/gcc/ada/namet.h
+++ b/gcc/ada/namet.h
@@ -25,7 +25,7 @@
 
 /* This is the C file that corresponds to the Ada package specification
    Namet.  It was created manually from files namet.ads and namet.adb.
-   Some subprograms from Sinput are also made acessable here.  */
+   Some subprograms from Sinput are also made accessible here.  */
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/gcc/ada/terminals.c b/gcc/ada/terminals.c
index dfadca8..9ad687b 100644
--- a/gcc/ada/terminals.c
+++ b/gcc/ada/terminals.c
@@ -1042,7 +1042,7 @@ __gnat_setup_winsize (void *desc, int rows, int columns)
 #define USE_CLONE_DEVICE "/dev/ptc"
 #elif defined (__hpux__)
 /* On HP-UX we use the streamed version. Using the non streamed version is not
-   recommanded (through "/dev/ptym/clone"). Indeed it seems that there are
+   recommended (through "/dev/ptym/clone"). Indeed it seems that there are
    issues to detect process terminations. */
 #define USE_CLONE_DEVICE "/dev/ptmx"
 #endif